//
//  CreaturesAppDelegate.m
//  Creatures
//
//  Created by Lenka on 07/12/2009.
//  Copyright Lenka Pitonakova 2009. All rights reserved.
//

/* REFERENCES
 1: Fothergill A. (2009) Rapid Game Development Using (Mostly) Standard C. In: Cabrera J. et. al, iPhone Games Projects, APress, p.61-100
*/

#import "CreaturesAppDelegate.h"
#import "EAGLView.h"
#import "World.h"
#import "Texture2D.h"




@implementation CreaturesAppDelegate



@synthesize window;
@synthesize glView;
@synthesize m_pWorld;



- (void)applicationDidFinishLaunching:(UIApplication *)application {
	
	
	//--------------- set timer of the application which will run the render loop each 1/FPS seconds:
    mTimer = [NSTimer scheduledTimerWithTimeInterval:(1.0/FPS) target:self selector:@selector(DoFrame) userInfo: nil repeats: YES];
	srandom(time(NULL));

	//-------------------- load textures into array:
	LoadTextureImage(CFSTR("terrain"),CFSTR("png"),TEX_TERRAIN);
	LoadTextureImage(CFSTR("units_bodies"),CFSTR("png"),TEX_UNITS_BODIES);
	LoadTextureImage(CFSTR("units_eyes"),CFSTR("png"),TEX_UNITS_EYES);
	LoadTextureImage(CFSTR("objs_static"),CFSTR("png"),TEX_OBJS_STAT);
	LoadTextureImage(CFSTR("objs_dynamic"),CFSTR("png"),TEX_OBJS_DYN);
	
	//---------------------------- create world:
	m_pWorld = [[World alloc] initWorld];
	[glView RegisterApp:self];
	//-------------------------------- set up rendering [REF 1]
	//Set up OpenGL projection matrix
	glMatrixMode(GL_PROJECTION);
	//------ landscape (get rid of rotate and swap values in Ortho for portait):
	glRotatef(270, 0, 0, 1);
	glOrthof(-240,240,-160,160, -1, 1);
	//---------
	glMatrixMode(GL_MODELVIEW);
	glViewport(0, 0, 320, 480);
	//Initialize OpenGL states
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	
	
}
/* DoFrame
 - repeats every frame, starts the Update-Render chain
*/

- (void) DoFrame {
	[glView startDrawing];
	[m_pWorld DoFrame];	
	[glView endDrawing];
}

- (void)applicationWillResignActive:(UIApplication *)application {
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
}


- (void)dealloc {
	[window release];
	[glView release];
	[World dealloc];
	[World release];
	[super dealloc];
}


@end
