//
//  ObjectDynamic.h
//  Creatures
//
//  Created by Lenka on 07/01/2010.
//  Copyright 2010 Lenka Pitonakova. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Sprite.h"



@class DynObjView;
@class DynObjMemory;
@class World;
@class DynObjModel;

@interface DynObjController : Sprite {
	DynObjView* m_pView;
	World* m_pWorld;
	Byte m_iType;
	NSInteger m_iToIdleCount;
	DynObjMemory* m_pMemory;
}

@property (nonatomic, retain) World* m_pWorld;
@property Byte m_iType;

- (id) initDynObj: (Byte)id_ type:(Byte)type_ pos:(CGPoint)pos_ rot:(CGFloat)rot_ world:(World*)world_; 
- (void) dealloc;
- (void) Update;
- (void) DoRendering;

- (BOOL) GetIsMoving;
- (void) UserOrder:(Byte)order_ atLocation:(CGPoint)loc_ withObject:(DynObjController*)withObj_;
- (void) Unselect;
- (void) GoIdle;
- (void) ScheduleIdleStateIn:(NSInteger)units_;
- (void) FinishedTask:(Byte)task_;

- (void) HandleTouchesBeginAt:(CGPoint)loc_;
- (void) HandleTouchesMovedAt:(CGPoint)loc_;
- (void) HandleTouchesEndedAt:(CGPoint)loc_;

- (NSString *) dataFilePathForKey: (NSString*)key_;
- (void) DecodeModelObject:(DynObjModel*) modelObject_ usingKey:(NSString*) objectKey_;
- (void) EncodeModelObject:(DynObjModel*) modelObject_ usingKey:(NSString*) objectKey_;

@end
