//
//  AgentMemory.m
//  Creatures
//
//  Created by Lenka on 22/12/2009.
//  Copyright 2009 Lenka Pitonakova. All rights reserved.
//

#import "DynObjMemory.h"
#import "DynObjController.h"

@implementation DynObjMemory

@synthesize m_CurTask;
@synthesize m_ptPos;
@synthesize m_fRot;


- (id) initMemoryWithController:(DynObjController*)control_ {
	m_pController = control_;
	m_CurTask.name = UORDER_NONE;
	m_CurTask.targetObj = NULL;
	[super initModelWithController:control_ encodingKey:@"dataMemory"];
	return self;
}

- (void) Update{
	BOOL finished = false;
	//----------------- decide if task finished yet:
	switch (m_CurTask.name) {
		case UORDER_BREED: {
			NSInteger tolerance = 50;
			if (m_pController.m_ptPos.x <= m_CurTask.targetObj.m_ptPos.x + tolerance && m_pController.m_ptPos.x >= m_CurTask.targetObj.m_ptPos.x - tolerance) {
				if (m_pController.m_ptPos.y <= m_CurTask.targetObj.m_ptPos.y + tolerance && m_pController.m_ptPos.y >= m_CurTask.targetObj.m_ptPos.y - tolerance) {
					finished = true;
				}
			}
		} break;
		case UORDER_MOVE: {
			NSInteger tolerance = 25;
			if (m_pController.m_ptPos.x <= m_CurTask.loc.x + tolerance && m_pController.m_ptPos.x >= m_CurTask.loc.x - tolerance) {
				if (m_pController.m_ptPos.y <= m_CurTask.loc.y + tolerance && m_pController.m_ptPos.y >= m_CurTask.loc.y - tolerance) {
					finished = true;
				}
			}
		} break;
	}
	//----------------- if task finished set current task to none:
	if (finished) {
		[m_pController FinishedTask:m_CurTask.name];
	}
}

- (void) SetTaskTo:(Byte)name_ atLocation:(CGPoint)loc_ withObject:(DynObjController*)withObj_{
	m_CurTask.name = name_;
	m_CurTask.loc = loc_;
	m_CurTask.targetObj = withObj_;
}

- (Byte) GetCurTaskName {
	return m_CurTask.name;
}
- (CGPoint) GetCurTaskLocation {
	return m_CurTask.loc;
}
- (DynObjController*) GetCurTaskTargetObj {
	return m_CurTask.targetObj;
}

#pragma mark ======================================= NSCoding
- (void) encodeWithCoder: (NSCoder*) encoder {
	//------------ encode each property and DynObjController's properties:
	[encoder encodeInteger: m_CurTask.name forKey: k1];
	[encoder encodeCGPoint:m_CurTask.loc forKey: k2];
	[encoder encodeCGPoint:m_pController.m_ptPos forKey: k3];
	[encoder encodeFloat:m_pController.m_fRot forKey: k4];

}

//---------------- decode:
- (id) initWithCoder: (NSCoder *) decoder {
	if (self == [super init]) {
		m_CurTask.name = [decoder decodeIntegerForKey:k1];
		m_CurTask.loc= [decoder decodeCGPointForKey:k2];
		m_ptPos = [decoder decodeCGPointForKey:k3];
		m_fRot = [decoder decodeFloatForKey:k4];
	}
	return self;
}

- (void) SetSelfWith: (DynObjMemory*)decodedObj_ {
	m_CurTask.name = decodedObj_.m_CurTask.name;
	m_CurTask.loc = decodedObj_.m_CurTask.loc;
	m_pController.m_ptPos = decodedObj_.m_ptPos;
	m_pController.m_fRot = decodedObj_.m_fRot;
}

@end
