//
//  Sprite.m
//  iCop Shooter
//
//  Created by Lenka on 27/08/2009.
//  Copyright 2009 Lenka Pitonakova. All rights reserved.
//

#import "Sprite.h"
//#import "EAGLView.h"

@implementation Sprite



@synthesize m_ptPos;
@synthesize m_ptSize;
@synthesize m_fRot;
@synthesize m_iId;

- (id) initStandard:(NSUInteger)id_ pos:(CGPoint)pos_ size:(CGPoint)size_ rot:(CGFloat)rot_ txtrId:(NSUInteger)texture_  {
	[super init];
	m_ptPos = pos_;
	m_ptSize = size_;
	m_fRot = rot_;
	m_iId = id_;
	m_iTextureId = texture_;
	//------- default UV coordinates, take whole texture:
	m_ptUcoordins = CGPointMake(0,1);
	m_ptVcoordins = CGPointMake(0,1);
	m_bShouldRender = true; // set to false by the Update function if Sprite out of screen bounds
	//----------- set this variable to render once when initialised
	return self;
}


- (void) Update {
	if (m_ptPos.y < -SCR_H - m_ptSize.y/2 || m_ptPos.y > SCR_H + m_ptSize.y/2) {
		m_bShouldRender = false;
	} else if (m_ptPos.x < -SCR_W - m_ptSize.x/2 || m_ptPos.x > SCR_W + m_ptSize.x/2) {
		m_bShouldRender = false;
	} else {
		m_bShouldRender = true;
	}
}

- (void) Render {	
	if (m_bShouldRender) {
		[self DoRendering]; // this function can be overriden by subclasses, keeping the m_bShouldRender check
		
	}
}
- (void) DoRendering {
	DrawSpriteAtWithUV(m_iTextureId,m_ptPos,0,m_ptUcoordins,m_ptVcoordins);	
}

- (BOOL) HitTest: (CGPoint)withPt {
	BOOL hit = false;
	if (withPt.y > m_ptPos.y - m_ptSize.y/2 && withPt.y < m_ptPos.y + m_ptSize.y/2) {
		if (withPt.x > m_ptPos.x - m_ptSize.x/2 && withPt.x < m_ptPos.x + m_ptSize.x/2) {
			hit = true;
		}
	}
	return hit;
}


 

@end
