//
//  UnitSensor.m
//  Creatures
//
//  Created by Lenka on 08/01/2010.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//


/* REFERENCES
 
 [1] Mark D. and LaMarche J. (2009) Beginning iPhone Development. New York, Apress, p. 173
 [2] http://stackoverflow.com/questions/1518309/objective-c-how-do-i-substring-an-email-address-in-text-field-to-firstpart-separ (accessed 09 Jan 2010)
 
 */


#import "UnitDNA.h"
#import "UnitController.h"

@implementation UnitDNA

@synthesize m_sDNAString;

- (id) initDNAWithController:(UnitController*) control_ {
	//----- generate random body and eyes color:
	NSInteger bodyCol = random() % 4; // [REF 1]
	NSInteger eyesCol = random() % 4;
	m_sDNAString =  [[NSString alloc] initWithFormat:@"%d_%d",bodyCol,eyesCol];
	[super initModelWithController:control_ encodingKey:@"dataDNA"];
	return self;
}

- (void) dealloc {
	[m_sDNAString release];
	[super dealloc];
}

- (Byte) GetBodyColor {
	NSString* bodyColStr = [[m_sDNAString componentsSeparatedByString:@"_"] objectAtIndex:0]; //[REF 2]
	NSInteger num = [bodyColStr intValue];
	Byte returnVal;
	switch (num) {
		case 0:
			returnVal = COL_PURPLE;
			break;
		case 1:
			returnVal = COL_RED;
			break;
		case 2:
			returnVal = COL_BLUE;
			break;
		case 3:
			returnVal = COL_GREEN;
			break;
	}
		
	return returnVal;
}

- (Byte) GetEyesColor {
	NSString* eyesColStr = [[m_sDNAString componentsSeparatedByString:@"_"] objectAtIndex:1]; //[REF 2]
	NSInteger num = [eyesColStr intValue];
	Byte returnVal;
	switch (num) {
		case 0:
			returnVal = COL_GREEN;
			break;
		case 1:
			returnVal = COL_BROWN;
			break;
		case 2:
			returnVal = COL_PURPLE;
			break;
		case 3:
			returnVal = COL_ORANGE;
			break;
	}
	
	return returnVal;
}

- (NSString*) GenerateChildStringWith:(NSString*)otherDNA_ {
	NSInteger temp = random() % 200;
	//----------------------- generate new body color from parent 1 or 2:
	NSInteger newBodyCol;
	if (temp <=100) {
		newBodyCol = [[[m_sDNAString componentsSeparatedByString:@"_"] objectAtIndex:0] intValue];
	} else {
		newBodyCol = [[[otherDNA_ componentsSeparatedByString:@"_"] objectAtIndex:0] intValue];
	}
	//----------------------- generate new eyes color from parent 1 or 2:
	NSInteger newEyesCol;
	temp = random() % 200;
	if (temp <= 100) {
		newEyesCol = [[[m_sDNAString componentsSeparatedByString:@"_"] objectAtIndex:1] intValue];
	} else {
		newEyesCol = [[[otherDNA_ componentsSeparatedByString:@"_"] objectAtIndex:1] intValue];
	}
	NSString* newDNA = [NSString stringWithFormat:@"%d_%d",newBodyCol,newEyesCol];
	return newDNA;
}

#pragma mark ======================================= NSCoding
/*
 Encode and decode class variables of individual Model objects.
 Only variables which change their value during the program runs need to be encoded/decoded.
 */


/*
 encodeWithCoder:
 - encodes an object when application closes
 */
- (void) encodeWithCoder: (NSCoder*) encoder {	
	 [encoder encodeObject: m_sDNAString forKey: k1];
}

/* initWithCoder:
 - decodes and object when application starts
 */
- (id) initWithCoder: (NSCoder *) decoder {
	
	if (self == [super init]) {
		self.m_sDNAString = [decoder decodeObjectForKey:k1];
	}
	return self;
}
/* SetSelfWith:
 - copies properties over from a decoded object
 */
- (void) SetSelfWith: (UnitDNA*)decodedObj_  {
	self.m_sDNAString = decodedObj_.m_sDNAString;
	 
}


@end
