//
//  World.h
//  Creatures
//
//  Created by Lenka on 07/12/2009.
//  Copyright 2009 Lenka Pitonakova. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Constants.h"


#define SETTINGS_FILE_NAME @"settings"

@class DynObjController;
@class StatObj;

@interface World : NSObject {
	StatObj *m_pStaticObjects [MAX_STAT_OBJS];
	DynObjController *m_pDynamicObjects [MAX_DYN_OBJS];
	NSInteger m_iNumStaticObjects;
	NSInteger m_iNumDynamicObjects;
	CGPoint m_ptGlobalCoordins;

}




- (id) initWorld;
- (void) dealloc;
- (void) DoFrame;
- (void) AddUnitAt: (CGPoint)pos_ rot:(CGFloat)rot_;
- (void) AddUnitAt: (CGPoint)pos_ rot:(CGFloat)rot_ withDNA:(NSString*)dna_;
- (void) AddStaticObjectAt: (CGPoint)pos_ rot:(CGFloat)rot_ type:(Byte)type_;
- (void) AddDynamicObjectAt: (CGPoint)pos_ rot:(CGFloat)rot_ type:(Byte)type_;

- (void) HandleTouchesBeginAt:(CGPoint)loc_;
- (void) HandleTouchesMovedAt:(CGPoint)loc_;
- (void) HandleTouchesEndedAt:(CGPoint)loc_;
- (DynObjController*) GetDynObjWithId:(NSInteger)id_;
- (void) UnselectAllOtherObjects:(NSUInteger)id_;
- (int) GetDynObjIdAt: (CGPoint)pos_ ;


- (NSString *) dataFilePath;
- (void) applicationWillTerminate: (NSNotification *) notification;

@end
